Imports Microsoft.Office.Core 'Core framework
Imports Extensibility 'ability to extend office
Imports System.Runtime.InteropServices

#Region " Read me for Add-in installation and setup information. "
' When run, the Add-in wizard prepared the registry for the Add-in.
' At a later time, if the Add-in becomes unavailable for reasons such as:
'   1) You moved this project to a computer other than which is was originally created on.
'   2) You chose 'Yes' when presented with a message asking if you wish to remove the Add-in.
'   3) Registry corruption.
' you will need to re-register the Add-in by building the FunnySaveSetup project 
' by right clicking the project in the Solution Explorer, then choosing install.
#End Region

'guid and product info
<GuidAttribute("2B858370-EBE4-497C-B9C3-A554C60F1AA5"), ProgIdAttribute("FunnySave.Connect")> _
Public Class Connect 'connect to "office app"

    Implements Extensibility.IDTExtensibility2

    Private applicationObject As Object 'application
    Private addInInstance As Object 'instance

    Private WithEvents btnFunny As CommandBarButton 'command button

    Sub SaveAllEmails_ProcessAllSubFolders()

        Dim i As Long 'first loop
        Dim j As Long 'second loop
        Dim Trunc As Long 'truncated name

        Dim StrSubject As String 'subject of email
        Dim StrName As String 'name of email
        Dim StrFile As String 'edited filename of email
        Dim StrReceived As String 'when was it recieved
        Dim StrSavePath As String 'path of file
        Dim StrFolder As String 'selected folder
        Dim StrFolderPath As String 'selected folder path
        Dim StrSaveFolder As String 'where to save to
        Dim Prompt As String 'prompt string
        Dim Title As String 'title of dialog

        Dim iNameSpace As Outlook.NameSpace 'namespace
        Dim OlApp As Outlook.Application 'app
        Dim SubFolder As Outlook.MAPIFolder 'folder
        Dim mItem As Outlook.MailItem 'email

        Dim FSO As Object 'file system object
        Dim ChosenFolder As Object 'which folder must we backup

        Dim Folders As New Collection 'all folders
        Dim EntryID As New Collection 'all entities
        Dim StoreID As New Collection 'all stores

        FSO = CreateObject("Scripting.FileSystemObject") 'create fso

        OlApp = New Outlook.Application 'create outlook instance
        iNameSpace = OlApp.GetNamespace("MAPI") 'get namespace

        ChosenFolder = iNameSpace.PickFolder 'choose folder to backup

        If ChosenFolder Is Nothing Then

            GoTo ExitSub

        End If

        Prompt = "Please enter the path to save all the emails to."
        Title = "Folder Specification"

        StrSavePath = BrowseForFolder() 'show & get output folder

        If StrSavePath = "" Then

            GoTo ExitSub

        End If

        If Not Right(StrSavePath, 1) = "\" Then 'add \ afterwards

            StrSavePath = StrSavePath & "\"

        End If

        Call GetFolder(Folders, EntryID, StoreID, ChosenFolder) 'get all folders

        For i = 1 To Folders.Count 'loop through folders

            StrFolder = StripIllegalChar(Folders(i)) 'remove chars that aren't allowed in filenames

            Trunc = InStr(3, StrFolder, "\") + 1 'remove \

            StrFolder = Mid(StrFolder, Trunc, 256) ' new name
            StrFolderPath = StrSavePath & StrFolder & "\" 'add \

            StrSaveFolder = Left(StrFolderPath, Len(StrFolderPath) - 1) & "\" 'get parent folder of message

            If Not FSO.FolderExists(StrFolderPath) Then 'create on system if nec

                FSO.CreateFolder(StrFolderPath)

            End If

            SubFolder = OlApp.Session.GetFolderFromID(EntryID(i), StoreID(i)) 'get all subfolders in main folder

            On Error Resume Next

            For j = 1 To SubFolder.Items.Count 'how many

                mItem = ChosenFolder.Items(j) 'get sub folder's items

                '       StrReceived = ArrangedDate(mItem.ReceivedTime) 'sort by date

                StrSubject = mItem.Subject 'get subject
                StrName = StripIllegalChar(StrSubject) 'strips invalid chars

                '     StrFile = StrSaveFolder & StrReceived & "_" & StrName & ".msg" 'new name

                StrFile = StrSaveFolder & StrName & ".msg" 'new name

                StrFile = Left(StrFile, 256)

                mItem.SaveAs(StrFile, 3) 'save

            Next j

            On Error GoTo 0

        Next i

ExitSub:

    End Sub

    '''strips invalid chars from subjects
    Function StripIllegalChar(ByVal StrInput)

        Dim RegX As Object 'regular expression object

        RegX = CreateObject("vbscript.regexp") 'create object

        'pattern to identify all ilegal chars
        RegX.Pattern = "[\" & Chr(34) & "\!\@\#\$\%\^\&\*\(\)\=\+\|\[\]\{\}\`\'\;\:\<\>\?\/\,]"

        RegX.IgnoreCase = True
        RegX.Global = True

        StripIllegalChar = RegX.Replace(StrInput, "") 'replace with empty string

ExitFunction:

        RegX = Nothing

    End Function

    '''sorts messages by date
    'Function ArrangedDate(ByVal StrDateInput)

    '    Dim StrFullDate As String 'full date
    '    Dim StrFullTime As String 'full time
    '    Dim StrAMPM As String 'am / pm?
    '    Dim StrTime As String 'time
    '    Dim StrYear As String 'year
    '    Dim StrMonthDay As String 'day of month
    '    Dim StrMonth As String 'month
    '    Dim StrDay As String 'day
    '    Dim StrDate As String 'whole date
    '    Dim StrDateTime As String 'date and time
    '    Dim RegX As Object 'regular expression

    '    RegX = CreateObject("vbscript.regexp") 'create reg ex object

    '    If Not Left(StrDateInput, 2) = "10" And _
    '    Not Left(StrDateInput, 2) = "11" And _
    '    Not Left(StrDateInput, 2) = "12" Then
    '        StrDateInput = "0" & StrDateInput 'append date to name of file
    '    End If

    '    StrFullDate = Left(StrDateInput, 10)

    'If Right(StrFullDate, 1) = " " Then

    '    StrFullDate = Left(StrDateInput, 9)

    'End If

    'StrFullTime = Replace(StrDateInput, StrFullDate & " ", "")

    'If Len(StrFullTime) = 10 Then

    '    StrFullTime = "0" & StrFullTime

    'End If

    'StrAMPM = Right(StrFullTime, 2)
    'StrTime = StrAMPM & "-" & Left(StrFullTime, 8) 'get am / pm

    'StrYear = Right(StrFullDate, 4)
    'StrMonthDay = Replace(StrFullDate, "/" & StrYear, "") 'append year

    '        StrMonth = Left(StrMonthDay, 2)
    '        StrDay = Right(StrMonthDay, Len(StrMonthDay) - 3) 'append day

    '        If Len(StrDay) = 1 Then
    '            StrDay = "0" & StrDay
    '        End If

    '        StrDate = StrYear & "-" & StrMonth & "-" & StrDay 'year / month / day

    '        StrDateTime = StrDate & "_" & StrTime

    '        RegX.Pattern = "[\:\/\ ]" ' check time string for colon

    '        RegX.IgnoreCase = True
    '        RegX.Global = True

    '        ArrangedDate = RegX.Replace(StrDateTime, "-") 'replace with hyphen

    'ExitFunction:

    '        RegX = Nothing

    '    End Function

    '''get outlook folders
    Sub GetFolder(ByVal Folders As Collection, ByVal EntryID As Collection, ByVal StoreID As Collection, ByVal Fld As Outlook.MAPIFolder)

        Dim SubFolder As Outlook.MAPIFolder 'folder object

        Folders.Add(Fld.FolderPath) 'path
        EntryID.Add(Fld.EntryID) 'entity
        StoreID.Add(Fld.StoreID) 'store

        For Each SubFolder In Fld.Folders 'loop through folders

            GetFolder(Folders, EntryID, StoreID, SubFolder)

        Next SubFolder

ExitSub:

        SubFolder = Nothing
        '    Call GetFolder(Folders, EntryID, StoreID, ChosenFolder) 'get all folders

    End Sub

    Sub CreateFolder_IfNec()

    End Sub

    '''displays browse for folder dialog box
    Function BrowseForFolder(Optional ByVal OpenAt As String = "C:\Documents and Settings\hannes\Desktop\To Backup") As String

        Dim ShellApp As Object ' object to host dialog

        ShellApp = CreateObject("Shell.Application"). _
        BrowseForFolder(0, "Please choose a folder", 0, OpenAt) 'create system dialog

        On Error Resume Next

        BrowseForFolder = ShellApp.self.Path 'set initial path

        On Error GoTo 0

        ''remove colons and slashes
        'Select Case Mid(BrowseForFolder, 2, 1)
        '    Case Is = ":"

        '        If Left(BrowseForFolder, 1) = ":" Then
        '            BrowseForFolder = ""
        '        End If

        '    Case Is = "\"

        '        If Not Left(BrowseForFolder, 1) = "\" Then
        '            BrowseForFolder = ""
        '        End If

        '    Case Else

        '        BrowseForFolder = ""

        'End Select

ExitFunction:

        ShellApp = Nothing

    End Function

    Public Sub OnBeginShutdown(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnBeginShutdown

        btnFunny.Delete() 'remove button
        btnFunny = Nothing
        applicationObject = Nothing 'remove references
    End Sub

    Public Sub OnAddInsUpdate(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnAddInsUpdate
    End Sub

    Public Sub OnStartupComplete(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnStartupComplete

        Dim cbCommandBars As CommandBars
        'Dim cbStandardBar As CommandBar
        Dim cbAdvancedBar As CommandBar

        On Error Resume Next

        ' Set up a custom button on the "Standard" command bar.
        cbCommandBars = applicationObject.CommandBars

        If cbCommandBars Is Nothing Then

            ' Outlook has the CommandBars collection on the Explorer object.
            cbCommandBars = applicationObject.ActiveExplorer.CommandBars

        End If

        'cbStandardBar = cbCommandBars.Item("Standard") 'connect to standard toolbar
        cbAdvancedBar = cbCommandBars.Item("Advanced")

        ' In case the button was not deleted, use the exiting one.
        'btnFunny = cbStandardBar.Controls.Item("Save Funnies")
        btnFunny = cbAdvancedBar.Controls.Item("Save Your Funnies")

        If btnFunny Is Nothing Then

            'btnFunny = cbStandardBar.Controls.Add(1)
            btnFunny = cbAdvancedBar.Controls.Add(1)

            With btnFunny

                .Caption = "Save Your Funnies"
                '.Style = MsoButtonStyle.msoButtonCaption
                .Style = MsoButtonStyle.msoButtonIconAndCaption
                '.Style = MsoButtonStyle.msoButtonIconAndWrapCaptionBelow
                .TooltipText = "Save Your Funnies"
                .FaceId = 1087
                '   .Picture = SFCI.getImage()


                .Tag = "Save Your Funnies"

                ' The OnAction property is optional but recommended. 
                ' It should be set to the ProgID of the add-in, so that if
                ' the add-in is not loaded when a user clicks the button,
                ' MSO loads the add-in automatically and then raises
                ' the Click event for the add-in to handle. 

                .OnAction = "!<MyCOMAddin.Connect>"

                .Visible = True

            End With

        End If

        ' cbStandardBar = Nothing
        cbAdvancedBar = Nothing
        cbCommandBars = Nothing

    End Sub

    Public Sub OnDisconnection(ByVal RemoveMode As Extensibility.ext_DisconnectMode, ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnDisconnection

        If RemoveMode <> Extensibility.ext_DisconnectMode.ext_dm_HostShutdown Then _
                  Call OnBeginShutdown(custom)

        applicationObject = Nothing 'remove references

        If RemoveMode = ext_DisconnectMode.ext_dm_UserClosed Then
            Call OnBeginShutdown(custom)
            applicationObject = Nothing 'remove references

        End If
    End Sub

    Public Sub OnConnection(ByVal application As Object, ByVal connectMode As Extensibility.ext_ConnectMode, ByVal addInInst As Object, ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnConnection

        applicationObject = application
        addInInstance = addInInst


        ' If you aren't in startup, manually call OnStartupComplete.
        If (connectMode <> Extensibility.ext_ConnectMode.ext_cm_Startup) Then _
           Call OnStartupComplete(custom)

    End Sub

    Private Sub btnFunny_Click(ByVal Ctrl As Microsoft.Office.Core.CommandBarButton, ByRef CancelDefault As Boolean) Handles btnFunny.Click

        SaveAllEmails_ProcessAllSubFolders() 'save emails

    End Sub

End Class
